require './config'
require 'csv'

pmcrm_type = "company"
entry_class = "pmcrm_" + pmcrm_type

csv_data = CSV.read($csv_file, headers: true)
puts "Starting Registrations..."

Dir.chdir($traction_dir) do
  csv_data.each do |data|

    title = "[[ /token pmcrm_company_title ]] +:todo"

    pmcrm_company_name = "#{data[0]}"
    pmcrm_company_pronunciation = "#{data[1]}"
    pmcrm_company_first_character = pmcrm_company_pronunciation[0]
    pmcrm_company_id = "#{data[2]}"
    pmcrm_company_other_id = "#{data[3]}"
    pmcrm_company_related_org = "#{data[4]}"
    pmcrm_company_other_info = "#{data[5]}"
    pmcrm_company_phone = "#{data[6]}"
    pmcrm_company_fax = "#{data[7]}"
    pmcrm_company_email = "#{data[8]}"
    pmcrm_company_website = "#{data[9]}"
    pmcrm_company_postal = "#{data[10]}"
    pmcrm_company_prefecture = "#{data[11]}"
    pmcrm_company_city = "#{data[12]}"
    pmcrm_company_address = "#{data[13]}"
    pmcrm_company_address_other = "#{data[14]}"
    goal_dashboard_milestones_max = "#{data[15]}"
    owners = "#{data[16]}"
    members = "#{data[17]}"
    pmcrm_assigned_group = "#{data[18]}"
    rank = "#{data[19]}"
    cat = "#{data[20]}"
    closing_month = "#{data[21]}"
    body = "#{data[22]}"

    if rank.empty?
      # Do Nothing
    else
      title = title + " +:" + rank
    end

    if cat.empty?
      # Do Nothing
    else
      title = title + " +:" + cat
    end

    if closing_month.empty?
      # Do Nothing
    else
      title = title + " +:" + closing_month
    end

    if pmcrm_assigned_group.empty?
      # Do Nothing
    else
      title = title + " [[ It3y3It this +::#{$space}:response:pmcrm_assigns_usergroup_to_company #{pmcrm_assigned_group} ]]"
    end

    # Don't insert the widget into the body.
    #body = "<p>[[ /token pmcrm_company_body1  ]]</p><p>" + body + "</p>"
    body = "<p>" + body + "</p>"

    puts ""
    puts "Posting #{pmcrm_company_name} ..."
    puts "----"
    puts "pmcrm_company_pronunciation = #{pmcrm_company_pronunciation}"
    puts "pmcrm_company_first_character = #{pmcrm_company_first_character}"
    puts "pmcrm_company_id = #{pmcrm_company_id}"
    puts "pmcrm_company_other_id = #{pmcrm_company_other_id}"
    puts "pmcrm_company_related_org = #{pmcrm_company_related_org}"
    puts "pmcrm_company_other_info = #{pmcrm_company_other_info}"
    puts "pmcrm_company_phone = #{pmcrm_company_phone}"
    puts "pmcrm_company_fax = #{pmcrm_company_fax}"
    puts "pmcrm_company_email = #{pmcrm_company_email}"
    puts "pmcrm_company_website = #{pmcrm_company_website}"
    puts "pmcrm_company_postal = #{pmcrm_company_postal}"
    puts "pmcrm_company_prefecture = #{pmcrm_company_prefecture}"
    puts "pmcrm_company_city = #{pmcrm_company_city}"
    puts "pmcrm_company_address = #{pmcrm_company_address}"
    puts "pmcrm_company_address_other = #{pmcrm_company_address_other}"
    puts "goal_dashboard_milestones_max = #{goal_dashboard_milestones_max}"
    puts "owners = #{owners}"
    puts "members = #{members}"
    puts "pmcrm_assigned_group = #{pmcrm_assigned_group}"
    puts "rank = #{rank}"
    puts "cat = #{cat}"
    puts "title = #{title}"

    `#{$traction_publish} -url #{$url} -auth #{$user}:#{$password} -project #{$space} -customEntryType goal -title \"#{title}\" -props "_class='#{entry_class}' pmcrm_company_name='#{pmcrm_company_name}' pmcrm_company_pronunciation='#{pmcrm_company_pronunciation}' pmcrm_company_first_character='#{pmcrm_company_first_character}' pmcrm_company_id='#{pmcrm_company_id}' pmcrm_company_other_id='#{pmcrm_company_other_id}' pmcrm_company_related_org='#{pmcrm_company_related_org}' pmcrm_company_other_info='#{pmcrm_company_other_info}' pmcrm_company_phone='#{pmcrm_company_phone}' pmcrm_company_fax='#{pmcrm_company_fax}' pmcrm_company_email='#{pmcrm_company_email}' pmcrm_company_website='#{pmcrm_company_website}' pmcrm_company_postal='#{pmcrm_company_postal}' pmcrm_company_prefecture='#{pmcrm_company_prefecture}' pmcrm_company_city='#{pmcrm_company_city}' pmcrm_company_address='#{pmcrm_company_address}' pmcrm_company_address_other='#{pmcrm_company_address_other}' owners='#{owners}' members='#{members}' goal_dashboard_milestones_max='#{goal_dashboard_milestones_max}'" -body \"#{body}\"`

    sleep($wait)

  end
end
